﻿using System.Collections.ObjectModel;

using Prism.Mvvm;

using TestLibrary.Business;

namespace TestLibrary.ViewModels
{
    /// <summary>
    /// 사람 리스트 뷰 모델
    /// </summary>
    public class PersonListViewModel : BindableBase
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 사람 컬렉션
        /// </summary>
        private ObservableCollection<Person> personCollection;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 사람 컬렉션 - PersonCollection

        /// <summary>
        /// 사람 컬렉션
        /// </summary>
        public ObservableCollection<Person> PersonCollection
        {
            get
            {
                return this.personCollection;
            }
            set
            {
                SetProperty(ref this.personCollection, value);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - PersonListViewModel()

        /// <summary>
        /// 생성자
        /// </summary>
        public PersonListViewModel()
        {
            ObservableCollection<Person> personCollection = new ObservableCollection<Person>();

            for(int i = 0; i < 10; i++)
            {
                personCollection.Add
                (
                    new Person()
                    {
                        FirstName = string.Format("First {0}", i),
                        LastName  = string.Format("Last {0}" , i),
                        Age       = i                    
                    }
                );
            }

            PersonCollection = personCollection;
        }

        #endregion
    }
}