﻿using System.ComponentModel;
using System.Windows.Controls;

using Prism.Common;
using Prism.Regions;

using TestLibrary.Business;
using TestLibrary.ViewModels;

namespace TestLibrary.Views
{
    /// <summary>
    /// 사람 뷰
    /// </summary>
    public partial class PersonView : UserControl
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - PersonView()

        /// <summary>
        /// 생성자
        /// </summary>
        public PersonView()
        {
            InitializeComponent();

            ObservableObject<object> context = RegionContext.GetObservableContext(this);
            
            context.PropertyChanged += context_PropertyChanged;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 컨텍스트 속성 변경시 처리하기 - context_PropertyChanged(sender, e)

        /// <summary>
        /// 컨텍스트 속성 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void context_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            ObservableObject<object> context = sender as ObservableObject<object>;

            Person person = context.Value as Person;

            (DataContext as PersonViewModel).SelectedPerson = person;
        }

        #endregion
    }
}